program wspornik;

//==============================================================================
// program generuje szkic rzędów otworów
//==============================================================================
procedure Add_CIR(x,y,r:extended);
var op:TPoint;
begin

  if (r<=0) then exit;

  op.x:=x+CirPointX(r,0);           // Okręgi z trzech łuków
  op.y:=y+CirPointY(r,0);
  SetG(0); SetPt(op); Write;

  op.x:=x+CirPointX(r,120);
  op.y:=y+CirPointY(r,120);
  SetG(3); SetPt(op); SetR(r);  write;

  op.x:=x+CirPointX(r,240);
  op.y:=y+CirPointY(r,240);
  SetG(3); SetPt(op); SetR(r);  write;

  op.x:=x+CirPointX(r,0);
  op.y:=y+CirPointY(r,0);
  SetG(3); SetPt(op); SetR(r);  write;

end;

//==============================================================================
procedure ADD_RECT_C(x,y,width,height,r:extended);
begin
  if (r=0) then begin
      SetG(0); SetX(x);  SetY(y);  write;
      SetG(1); SetX(x+width); write;
      SetG(1); SetY(y+height); write;
      SetG(1); SetX(x);  write;
      SetG(1); SetY(y);  write;
      exit;
  end;

  SetG(0); SetX(x+r);  SetY(y);  write;
  SetG(1); SetX(x+width-r); write;
  SetG(3); SetX(x+width); SetY(y+r); SetR(r);  write;
  SetG(1); SetY(y+height-r); write;
  SetG(3); SetX(x+width-r);  SetY(y+height); SetR(r); write;
  SetG(1); SetX(x+r);  write;
  SetG(3); SetX(x);  SetY(y+height-r); SetR(r);  write;
  SetG(1); SetY(y+r);  write;
  SetG(3); SetX(x+r);  SetY(y); SetR(r); write;

end;

var  k1,k2,k3,k1w,k2w,k3w:TLine;  pc:TPoint; i,j:cardinal;  Wx,Wy,xp,yp,wsp:extended;
begin

  if (RUN_CNT=0) then begin  // wykonywane tylko przy pierwszym uruchomieniu
   SetArgPic('Detal_info.jpg');   // obrazek objaśniający
   SetArg(0,'A (mm)',5.0);
   SetArg(2,'Wx (mm)',150.0);
   SetArg(3,'Wy (mm)',80.0);
   SetArg(4,'D (mm)',8.0);
  end;

  // Organizujeny sposób wyświetlania parametrów
  ArgPageTitle('detal - parametry');    // nazwa pierwszej zakładki
  ArgSeparator('Szkic - po wygenerowaniu eksportować G kod do cam !');
  ArgShow(2);
  ArgShow(3);
  ArgShow(0);
  ArgShow(4);
  ArgSeparator('Autor: Andrzej Woźniak  Damasławek 2013');
  ArgEdit;  // i otwarcie okna edycji parametrów

  xp:=Arg(0); yp:=Arg(0); wsp:=2*Arg(4);
  Wx:=Arg(2)-(2*xp); Wy:=Arg(3)-(2*yp);

  SetG(0); SetZ(0); write;         // wnętrze
  SetX(xp+wsp); SetY(yp); write;

  SetG(1); SetX(xp+Wx-wsp); write;
  SetY(yp+wsp); write;
  SetX(xp+Wx); write;
  SetY(yp+Wy-wsp); write;
  SetX(xp+Wx-wsp); write;
  SetY(yp+Wy); write;
  SetX(xp+wsp); write;
  SetY(yp+Wy-wsp); write;
  SetX(xp); write;
  SetY(yp+wsp); write;
  SetX(xp+wsp);write;
  SetY(yp); write;

  if (Arg(4)>0) then begin        // Otwory
    SetG(0); SetZ(-1); write;
    Add_CIR(xp+(wsp/2),yp+(wsp/2),Arg(4)/2);
    Add_CIR(xp+Wx-(wsp/2),yp+(wsp/2),Arg(4)/2);
    Add_CIR(xp+Wx-(wsp/2),yp+Wy-(wsp/2),Arg(4)/2);
    Add_CIR(xp+(wsp/2),yp+Wy-(wsp/2),Arg(4)/2);
  end;

  if (xp>0) then begin           // Dekielek
    SetG(0); SetZ(-1.1); write;
    ADD_RECT_C(0,0,Arg(2),Arg(3),Arg(4)/2);
  end;

end.
