program wspornik;

//==============================================================================
// program generuje szkic rzędów otworów
//==============================================================================
procedure Add_CIR(x,y,r:extended);
var op:TPoint;
begin

  op.x:=x+CirPointX(r,0);           // Okręgi z trzech łuków
  op.y:=y+CirPointY(r,0);
  SetG(0); SetPt(op); Write;

  op.x:=x+CirPointX(r,120);
  op.y:=y+CirPointY(r,120);
  SetG(3); SetPt(op); SetR(r);  write;

  op.x:=x+CirPointX(r,240);
  op.y:=y+CirPointY(r,240);
  SetG(3); SetPt(op); SetR(r);  write;

  op.x:=x+CirPointX(r,0);
  op.y:=y+CirPointY(r,0);
  SetG(3); SetPt(op); SetR(r);  write;

end;


var  i,j:cardinal;
begin

  if (RUN_CNT=0) then begin  // wykonywane tylko przy pierwszym uruchomieniu
   SetArgPic('DrillTable_info.jpg');   // obrazek objaśniający
   SetArg(0,'A (mm)',20.0);
   SetArg(1,'B (mm)',20.0);
   SetArg(2,'Px (mm)',30.0);
   SetArg(3,'Py (mm)',20.0);
   SetArg(4,'D1 (mm)',15.0);
   SetArg(8,'D2 (mm) [zero oznacza brak]',0.0);
   SetArg(5,'Ilość otworów poziomo',4);
   SetArg(6,'Ilość otworów pionowo',4);
   SetArg(7,'*Ramka/TAK/NIE',0);
   SetArg(9,'*TRYB/Tablica/Po obwodzie',0);
  end;

  // Organizujeny sposób wyświetlania parametrów
  ArgPageTitle('Rzędy otworów - parametry');    // nazwa pierwszej zakładki
  ArgSeparator('Szkic - po wygenerowaniu eksportować G kod do cam !');
  ArgShow(0);
  ArgShow(1);
  ArgShow(2);
  ArgShow(3);
  ArgShow(4);
  ArgShow(8);
  ArgShow(5);
  ArgShow(6);
  ArgShow(7);
  ArgShow(9);
  ArgSeparator('Autor: Andrzej Woźniak  Damasławek 2013');
  ArgEdit;  // i otwarcie okna edycji parametrów

  SetG(0); SetZ(0); write;

  if (Arg(4)>0) then begin
    i:=0;
    while (i<Arg(5)) do begin   // pierwsze koło
      j:=0;
      while (j<Arg(6)) do begin
        if (Arg(9)=0) or ((i=0) or (i=(Arg(5)-1))) or ((j=0) or (j=(Arg(6)-1))) then begin
          Add_CIR(Arg(0)+(i*Arg(2)),Arg(1)+(j*Arg(3)),Arg(4)/2);
        end;
        Inc(j);
      end;
      Inc(i);
    end;
  end;

  if (Arg(8)>0) then begin    // drugie koło
    SetG(0); SetZ(-1); write;
    i:=0;
    while (i<Arg(5)) do begin
      j:=0;
      while (j<Arg(6)) do begin
        if (Arg(9)=0) or ((i=0) or (i=(Arg(5)-1))) or ((j=0) or (j=(Arg(6)-1))) then begin
          Add_CIR(Arg(0)+(i*Arg(2)),Arg(1)+(j*Arg(3)),Arg(8)/2);
        end;
        Inc(j);
      end;
      Inc(i);
    end;
  end;


  if (Arg(7)=0) then begin       // Ramka
     SetG(0); SetZ(-2); write;
     SetG(0); SetX(0); SetY(0); write;
     SetG(1); SetX(2*Arg(0)+((Arg(5)-1)*Arg(2))); write;
     SetG(1); SetY(2*Arg(1)+((Arg(6)-1)*Arg(3))); write;
     SetG(1); SetX(0); write;
     SetG(1); SetY(0); write;
  end;

end.
